VERSION 5.00
Begin VB.Form frmDlg 
   ClientHeight    =   3495
   ClientLeft      =   6120
   ClientTop       =   1935
   ClientWidth     =   4140
   LinkTopic       =   "Form1"
   ScaleHeight     =   3495
   ScaleWidth      =   4140
   Begin VB.ListBox List1 
      Height          =   3180
      Left            =   150
      TabIndex        =   0
      Top             =   120
      Width           =   3795
   End
End
Attribute VB_Name = "frmDlg"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False

'This form is the form that will "hold" the dialog

'definition of RECT from API, normally my type library
Private Type RECT
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
End Type

'SendMessage is used to change the tabstops in the listbox
Private Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Long) As Long

'these calls are used to put the listbox onto the dialog and get screen information
Private Declare Function GetSystemMetrics Lib "user32" (ByVal nIndex As Long) As Long
Private Declare Function GetWindowRect Lib "user32" (ByVal hwnd As Long, lpRect As RECT) As Long
Private Declare Function GetParent Lib "user32" (ByVal hwnd As Long) As Long
Private Declare Function SetParent Lib "user32" (ByVal hWndChild As Long, ByVal hWndNewParent As Long) As Long
Private Declare Function MoveWindow Lib "user32" (ByVal hwnd As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal bRepaint As Long) As Long

'constants
Private Const LB_SETTABSTOPS = 402
Private Const SM_CYCAPTION = 4
Private Const SM_CXDLGFRAME = 7
Private Const SM_CYDLGFRAME = 8

'defining the class with events allows you to receive the events that the class
'will send if the dialog is hooked.  Hooking is also known as subclassing if you didn't
'know that.
Public WithEvents FileDialog As cNewDialog
Attribute FileDialog.VB_VarHelpID = -1

'variable to hold the handle of the common dialog
Private m_hWnd As Long

Private Sub Form_Load()
   'change the tabstops of the listbox
   SendMessage List1.hwnd, LB_SETTABSTOPS, 1&, 145&
End Sub

Private Sub FileDialog_InitDialog(ByVal hDlg As Long)
   'initialize the dialog box
   Dim R As RECT
   Dim BorderSize  As Long
    
   'get the handle of the dialog
   m_hWnd = GetParent(hDlg)
   'get the size of it
   GetWindowRect m_hWnd, R
   'get the size of the borders
   BorderSize = GetSystemMetrics(SM_CXDLGFRAME)
   'change the size of the window to allow space for our listbox
   'if we don't center the dialog, it will appear on the top left due to the 0&,0&
   MoveWindow m_hWnd, 0&, 0&, R.Right - R.Left + List1.Width \ Screen.TwipsPerPixelX + BorderSize * 2, R.Bottom - R.Top, 1
   'center the dialog to the screen (can send any object to center to, as long as it has Lett, Top, Height and Width properties)
   FileDialog.CenterDialog hDlg, Screen
   'add the listbox to the dialog
   SetParent List1.hwnd, m_hWnd
   'and move the listbox to the right spot
   MoveWindow List1.hwnd, R.Right - R.Left - BorderSize, 4&, List1.Width \ Screen.TwipsPerPixelX, R.Bottom - R.Top - GetSystemMetrics(SM_CYCAPTION) - GetSystemMetrics(SM_CYDLGFRAME) * 2 - 6, 1
End Sub
Private Sub FileDialog_DialogClose()
   'put the listbox back on this form when the dialog closes
   SetParent List1.hwnd, Me.hwnd
End Sub

Private Sub FileDialog_FileChange(ByVal hDlg As Long)
   'the user selected a file, process it
   Dim sFileName As String
    'get the name of the file
   sFileName = GetComDlgFileName(hDlg)
   'and load the listbox with the info from the playlist, note, if the user selected
   'something other than an M3U file, The LoadPlaylist sub will clear the list
   LoadPlaylist sFileName
End Sub

Public Sub LoadPlaylist(ByVal sFileName As String)
   'this sub will read an Extended Playlist and put the contents in the listbox
   Dim fn As Integer
   Dim CommaPos As Long
   Dim DurInSecs As Long
   Dim sArtistTitle As String
   Dim Counter As Long
   Dim s As String
   'clear the list
   List1.Clear
   'check to make sure the file has a M3U extension
   'we need to make sure sFileName has more than 3 chars to aviod error
   If Len(sFileName) < 3 Then Exit Sub
   'if Len(sFilename) < 3 then an error is generated here.
   If Right$(UCase$(sFileName), 3) <> "M3U" Then Exit Sub
   'set error trap
   On Error GoTo Hell
   'read the file
   fn = FreeFile
   Open sFileName For Input As #fn
   Line Input #fn, s
   'check to make sure it is an extended m3u
   If s <> "#EXTM3U" Then GoTo Hell
     Do 'until we get to the end of the file
      Line Input #fn, s
      'check to make sure the information is extended
      If Left(s, 7) = "#EXTINF" Then
         'find the comma
         CommaPos = InStr(1, s, ",")
         If CommaPos > 0 Then
            'get the duration
            DurInSecs = Val(Mid$(s, 9, CommaPos - 9))
            'get the artist and title
            sArtistTitle = Right$(s, Len(s) - CommaPos)
         End If
      End If
      'get the filename
      Line Input #fn, s
      Counter = Counter + 1
      'build the line for the listbox
      s = Counter & ". " & sArtistTitle & vbTab & FormatTime(DurInSecs) & vbTab & s
      'add it to the listbox
      List1.AddItem s
   Loop While Not EOF(fn)
   'close the file
   Close
   'exit
   Exit Sub
Hell:
   'got an error, close the file
   Close
End Sub

Function FormatTime(ByVal Secs As Long) As String
   'converts number of seconds to hh:mm:ss or mm:ss if hours = 0
   Dim Hrs As Long
   Dim Min As Long
   Dim Sec As Long
   Dim s As String
   Hrs = Secs \ 3600
   Min = Secs \ 60 Mod 60
   Sec = Secs Mod 60
   If Hrs > 0 Then s = Format$(Hrs, "00:")
   FormatTime = s & Format$(Min, "00:") & Format$(Sec, "00")
End Function
